//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#include "Repeater.h"

Define_Module(Repeater);

void Repeater::initialize()
{
    random = par("random");
    interval = par("interval");
    timer = new cMessage("TIMER", TIMER);
}

void Repeater::handleMessage(cMessage *msg)
{
	simtime_t delay;
	Messages *t;

    switch(msg->getKind()){
    case DATA:
    	data = msg;
    	if(random){
    		delay = (simtime_t)uniform(0.5, 1.5);
    	} else {
    		delay = (simtime_t)interval;
    	}
    	t = new Messages("TIMER", TIMER);
    	t->setData((long) data);
    	scheduleAt(simTime() + delay, t);
    	break;
    case TIMER:
    	t = check_and_cast<Messages *>(msg);
    	send((cMessage *) t->getData(), gate("outGate", ((Messages *)t->getData())->getArrivalGate()->getIndex()));
    	delete msg;
    	break;
    }
}

void Repeater::finish(){
	delete timer;
}
